<template>
  <article class="view view--forum">
    <h2 class="no-highlight">
      <a aria-expanded="true" aria-label="Collapse recent posts" @click="onRecentPostsClick">
        <i aria-hidden="true" :class="collapseIcon(recentPostsShown)"></i> Recent posts
      </a>
    </h2>
    <div class="collapse show" ref="recentPostsRef">
      <PostList :route="route" :limit="6" view="grid" :pagination="false" sort="-created" />
    </div>

    <h2 class="no-highlight">
      <a aria-expanded="true" aria-label="Collapse categories" @click="onCategoriesClick">
        <i aria-hidden="true" :class="collapseIcon(categoriesShown)"></i> Categories
      </a>
    </h2>
    <div class="collapse show" ref="categoriesRef">
      <CategoryList />
    </div>

    <h2>Users</h2>
    <UserOverview />
  </article>
</template>

<script>
import { ref, onMounted } from 'vue'
import { useRoute } from 'vue-router'
import { UserOverview } from '../../../identity'
import PostList from '../../components/post-list.vue'
import CategoryList from '../../components/category-list.vue'

export default {
  name: 'ForumView',
  components: {
    PostList,
    CategoryList,
    UserOverview,
  },
  setup() {
    const route = useRoute()

    const recentPostsRef = ref(null)
    const categoriesRef = ref(null)

    const recentPostsShown = ref(true)
    const categoriesShown = ref(true)
    const recentPostsCollapse = ref(undefined)
    const categoriesCollapse = ref(undefined)

    const onRecentPostsClick = () => {
      recentPostsShown.value = !recentPostsShown.value
      recentPostsCollapse.value.toggle(recentPostsShown.value)
    }

    const onCategoriesClick = () => {
      categoriesShown.value = !categoriesShown.value
      categoriesCollapse.value.toggle(categoriesShown.value)
    }

    const collapseIcon = (shown) => {
      return shown ? 'bi-chevron-down' : 'bi-chevron-up'
    }

    onMounted(() => {
      recentPostsCollapse.value = new bootstrap.Collapse(recentPostsRef.value, { toggle: false })
      categoriesCollapse.value = new bootstrap.Collapse(categoriesRef.value, { toggle: false })
    })

    return {
      route,
      recentPostsRef,
      categoriesRef,
      recentPostsShown,
      categoriesShown,
      onRecentPostsClick,
      onCategoriesClick,
      collapseIcon,
    }
  },
}
</script>

<style lang="scss">
h2 a {
  text-decoration: none;
  cursor: pointer;
}
</style>
